<template>
  <div class="page-bulmachartjs scrollable">
    <div class="page-header">
      <h1>Dashboard</h1>
      <el-breadcrumb separator="/">
        <el-breadcrumb-item :to="{ path: '/' }"><i class="mdi mdi-home-outline"></i></el-breadcrumb-item>
        <el-breadcrumb-item>Dashboard</el-breadcrumb-item>
      </el-breadcrumb>
    </div>
    <!-- <div
      class="card-base card-shadow--medium bg-white black-text p-30 mt-40 card-base-chart"
    > -->

    <el-row
      :gutter="20"
      class="row-filter-chart"
    >
      <el-card class="box-card flex justify-space-between box-card-custom-height">

        <el-date-picker
          class="datepicker-chart-custom"
          @change="changePicker"
          v-model="datepicker"
          type="daterange"
          range-separator="-"
          start-placeholder="Start date"
          end-placeholder="End date"
          format="dd-MM-yyyy"
          :default-value="datepicker"
          value-format="yyyy-MM-dd"
          size="small"
        >
        </el-date-picker>
      </el-card>
    </el-row>

    <div
      class="chart-box chart-box-h100"
      style="height: auto; width:100%; margin-top:40px;"
    >
       <!-- new 1 -->
     <el-row
        :gutter="20"
        class="el-row-custom-bt-20"
      >
      <el-col
          :span="12"
          v-loading="activeEmployerLoading"
        >
          <el-card class="box-card">
            <div
              slot="header"
              class="clearfix"
            >
              <strong>Active Employer</strong>
            </div>
            <bulma-chart
              ref="_chartActiveEmployer"
              :type="'bar'"
              :data="activeEmployerData"
              :options="optionChart"
            ></bulma-chart>
          </el-card>
        </el-col>
        <el-col
          :span="12"
          v-loading="ActiveSeekersLoading"
        >
          <el-card class="box-card">
            <div
              slot="header"
              class="clearfix"
            >
              <strong> Active Job Seeker</strong>
            </div>
            <bulma-chart
              ref="_chartActiveSeeker"
              :type="'bar'"
              :data="ActiveSeekersData"
              :options="optionChart"
            ></bulma-chart>
          </el-card>
        </el-col>
      </el-row>
      <!-- new 2 -->
      <el-row
        :gutter="20"
        class="el-row-custom-bt-20"
      >
        <el-col
          :span="12"
          v-loading="newEmployerLoading"
        >
          <el-card class="box-card">
            <div
              slot="header"
              class="clearfix"
            >
              <strong>New Employer</strong>
            </div>
            <bulma-chart
              ref="_newEmployerData"
              :type="'bar'"
              :data="newEmployerData"
              :options="optionChart"
            ></bulma-chart>
          </el-card>
        </el-col>

        <el-col
          :span="12"
          v-loading="newSeekersLoading"
        >
          <el-card class="box-card">
            <div
              slot="header"
              class="clearfix"
            >
              <strong>New Job Seeker</strong>
            </div>
            <bulma-chart
              ref="_chartseeker"
              :type="'bar'"
              :data="seekersData"
              :options="optionChart"
            ></bulma-chart>
          </el-card>
        </el-col>

      </el-row>
<!-- new 3 -->
      <el-row
        :gutter="20"
        class="el-row-custom-bt-20"
      >
      <el-col
          :span="12"
          v-loading="profileCompletedSeekerLoading"
        >
          <el-card class="box-card">
            <div
              slot="header"
              class="clearfix"
            >
              <strong> New Profile Completed Job Seeker</strong>
            </div>
            <bulma-chart
              ref="_chartProfileSeeker"
              :type="'bar'"
              :data="profileCompletedSeekersData"
              :options="optionChart"
            ></bulma-chart>
          </el-card>
        </el-col>

        <el-col
          :span="12"
          v-loading="workplacesLoading"
        >
          <el-card class="box-card">
            <div
              slot="header"
              class="clearfix"
            >
              <strong>New Company</strong>
            </div>
            <bulma-chart
              ref="_chartworkplaces"
              :type="'bar'"
              :data="workplacesData"
              :options="optionChart"
            ></bulma-chart>
          </el-card>
        </el-col>

      </el-row>
<!-- new 4 -->
      <el-row
        :gutter="20"
        class="el-row-custom-bt-20"
      >
       <el-col
          :span="12"
          v-loading="jobspostsLoading"
        >
          <el-card class="box-card">
            <div
              slot="header"
              class="clearfix"
            >
              <strong>New Job Post</strong>
            </div>
            <bulma-chart
              ref="_chartjobsposts"
              :type="'bar'"
              :data="jobsPostsData"
              :options="optionChart"
            ></bulma-chart>
          </el-card>
        </el-col>

        <el-col
          :span="12"
          v-loading="JobApplicationLoading"
        >
          <el-card class="box-card">
            <div
              slot="header"
              class="clearfix"
            >
              <strong>New Job Application</strong>
            </div>
            <bulma-chart
              ref="_chartappli"
              :type="'bar'"
              :data="Applicationdata"
              :options="optionChart"
            ></bulma-chart>
          </el-card>
        </el-col>

      </el-row>
<!-- new 5 -->
      <el-row
        :gutter="20"
        class="el-row-custom-bt-20"
      >
      <el-col
          :span="12"
          v-loading="chatsLoading"
        >
          <el-card class="box-card">
            <div
              slot="header"
              class="clearfix"
            >
              <strong>Unlock Chat</strong>
            </div>
            <bulma-chart
              ref="_chartchats"
              :type="'bar'"
              :data="chatsData"
              :options="optionChart"
            ></bulma-chart>
          </el-card>
        </el-col>
        <el-col
          :span="12"
          v-loading="jobsoffersLoading"
        >
          <el-card class="box-card">
            <div
              slot="header"
              class="clearfix"
            >
              <strong>Offer Job</strong>
            </div>
            <bulma-chart
              ref="_chartjobsoffers"
              :type="'bar'"
              :data="jobOffersData"
              :options="optionChart"
            ></bulma-chart>
          </el-card>
        </el-col>
      </el-row>

      <el-row
        :gutter="20"
        class="el-row-custom-bt-20"
      >
      <el-col
          :span="12"
          v-loading="honeyspendingLoading"
        >
          <el-card class="box-card">
            <div
              slot="header"
              class="clearfix"
            >
              <strong>Honey Spend</strong>
            </div>
            <bulma-chart
              ref="_chartspending"
              :type="'bar'"
              :data="honeySpendingData"
              :options="optionChart"
            ></bulma-chart>
          </el-card>
        </el-col>
        <el-col
          :span="12"
          v-loading="honeybuyingLoading"
        >
          <el-card class="box-card">
            <div
              slot="header"
              class="clearfix"
            >
              <strong>Honey Buy</strong>
            </div>
            <bulma-chart
              ref="_chartbuying"
              :type="'bar'"
              :data="honeyBuyingData"
              :options="optionChart"
            ></bulma-chart>
          </el-card>
        </el-col>
      </el-row>
    <!-- end -->

    </div>

  </div>

  <!-- </div> -->
</template>
<script>
import helper from '~/services/helper'
import { statistic as statisticAPI } from '~/services/apis/index'
export default {
  data () {
    return {
      activeEmployerLoading: false,
      newEmployerLoading: false,
      profileCompletedSeekerLoading: false,
      newSeekersLoading: false,
      ActiveSeekersLoading: false,
      workplacesLoading: false,
      chatsLoading: false,
      jobspostsLoading: false,
      jobsoffersLoading: false,
      honeybuyingLoading: false,
      honeyspendingLoading: false,
      JobApplicationLoading: false,
      optionChart: {
        maintainAspectRatio: false,
        responsive: true,
        scales: {
          //config yAxes display Integer value instead Float
          yAxes: [
            {
              ticks: {
                beginAtZero: true,
                callback: function (value) {
                  if (value % 1 === 0) {
                    return value;
                  }
                }
              }
            }
          ]
        },
        tooltips: {
          mode: 'label'
        }
      },
      activeName: 'seekers',
      //Get default value of Datepicker -> Return 'Today' & '7days ago'
      datepicker: [this.$moment().subtract(7, 'days').format('YYYY-MM-DD'), this.$moment(new Date()).format('YYYY-MM-DD')],
      tabLoading: false,
      labelsSeeker: [],
      labelsProfileCompletedSeeker: [],
      labelNewEmployer: [],
      labelActiveEmployer: [],
      labelsWorkplaces: [],
      labelChats: [],
      labelJobsPosts: [],
      labelJobsOffers: [],
      labelHoneyBuying: [],
      labelHoneySpending: [],
      labelJobApplication: [],
      labelActiveJobSeeks: [],

      seekers: {
        label: 'New Job Seeker',
        backgroundColor: 'rgba(102,153,255,.5)',
        data: []
      },
      ActiveSeekers: {
        label: 'Active Job Seeker',
        backgroundColor: 'rgba(74,89,106,.5)',
        data: []
      },
      profilecomplete_seekers: {
        label: 'New Profile Completed Job Seeker',
        backgroundColor: 'rgba(255,153,0,.6)',
        data: []
      },
      newEmployer: {
        label: 'New Employer',
        backgroundColor: 'rgba(51,204,51,.5)',
        data: []
      },
      activeEmployer: {
        label: 'Active Employer',
        backgroundColor: 'rgba(102,0,102,.5)',
        data: []
      },
      workplaces: {
        label: 'Company',
        backgroundColor: 'rgba(204,204,102,.5)',
        data: []
      },
      jobs_post: {
        label: 'Jobs Post',
        backgroundColor: 'rgba(255,153,51,.5)',
        data: []
      },
      Application_chart: {
        label: 'Job Application',
        backgroundColor: 'rgba(220, 27, 22,.5)',
        data: []
      },
      chats: {
        label: 'Unlock Chat',
        backgroundColor: 'rgba(255,102,204,.5)',
        data: []
      },
      jobs_offer: {
        label: 'Offer Job',
        backgroundColor: 'rgba(86 ,217 ,254,0.5)',
        data: []
      },
      honeysBuying: {
        label: 'Honey Buying Amount',
        backgroundColor: 'rgba(97, 250, 151, .5)',
        data: [],
      },

      honeysSpending: {
        label: 'Honey Spending Amount',
        backgroundColor: 'rgba(91 ,86 ,255, .5)',
        data: [],
      },


    }
  },

  computed: {
    seekersData () {
      if (this.$refs._chartseeker) {
        this.$nextTick(() => {
          this.$refs._chartseeker.resetChart()
        })
      }
      return {
        labels: this.labelsSeeker,
        datasets: [this.seekers]
      }
    },
    ActiveSeekersData () {
      if (this.$refs._chartActiveSeeker) {
        this.$nextTick(() => {
          this.$refs._chartActiveSeeker.resetChart()
        })
      }
      return {
        labels: this.labelActiveJobSeeks,
        datasets: [this.ActiveSeekers]
      }
    },
    newEmployerData () {
      if (this.$refs._newEmployerData) {
        this.$nextTick(() => {
          this.$refs._newEmployerData.resetChart()
        })
      }
      return {
        labels: this.labelNewEmployer,
        datasets: [this.newEmployer]
      }
    },
    activeEmployerData () {
      if (this.$refs._chartActiveEmployer) {
        this.$nextTick(() => {
          this.$refs._chartActiveEmployer.resetChart()
        })
      }
      return {
        labels: this.labelActiveEmployer,
        datasets: [this.activeEmployer]
      }
    },
    profileCompletedSeekersData () {

      if (this.$refs._chartProfileSeeker) {
        this.$nextTick(() => {
          this.$refs._chartProfileSeeker.resetChart()
        })
      }
      return {
        labels: this.labelsProfileCompletedSeeker,
        datasets: [this.profilecomplete_seekers]
      }
    },
    workplacesData () {

      if (this.$refs._chartworkplaces) {
        this.$nextTick(() => {
          this.$refs._chartworkplaces.resetChart()
        })
      }
      return {
        labels: this.labelsWorkplaces,
        datasets: [this.workplaces],
      }
    },
    chatsData () {

      if (this.$refs._chartchats) {
        this.$nextTick(() => {
          this.$refs._chartchats.resetChart()
        })
      }
      return {
        labels: this.labelChats,
        datasets: [this.chats],
      }
    },
    jobOffersData () {

      if (this.$refs._chartjobsoffers) {
        this.$nextTick(() => {
          this.$refs._chartjobsoffers.resetChart()
        })
      }
      return {
        labels: this.labelJobsOffers,
        datasets: [this.jobs_offer],
      }
    },
    jobsPostsData () {

      if (this.$refs._chartjobsposts) {
        this.$nextTick(() => {
          this.$refs._chartjobsposts.resetChart()
        })
      }
      return {
        labels: this.labelJobsPosts,
        datasets: [this.jobs_post],
      }
    },
    Applicationdata () {

      if (this.$refs._chartappli) {
        this.$nextTick(() => {
          this.$refs._chartappli.resetChart()
        })
      }
      return {
        labels: this.labelJobApplication,
        datasets: [this.Application_chart],
      }
    },
    honeySpendingData () {

      if (this.$refs._chartspending) {
        this.$nextTick(() => {
          this.$refs._chartspending.resetChart()
        })
      }
      return {
        labels: this.labelHoneySpending,
        datasets: [this.honeysSpending],
      }
    },
    honeyBuyingData () {

      if (this.$refs._chartbuying) {
        this.$nextTick(() => {
          this.$refs._chartbuying.resetChart()
        })
      }
      return {
        labels: this.labelHoneyBuying,
        datasets: [this.honeysBuying],
      }
    },
  },
  methods: {
    /** Get all chart
     *@start String
     *@end String
     */
    getAllTraffic (start, end) {
      const newSeeker = 'new';
      const profile_completed = 'profile_completed'
      const active = 'active'

      start ? start : start = this.datepicker[0]
      end ? end : end = this.datepicker[1]
      this.getTrafficSeekerNew(start, end, newSeeker)
      this.getTrafficSeekerProfileCompleted(start, end, profile_completed)
      this.getTrafficWorkplace(start, end)
      this.getTrafficChat(start, end)
      this.getTrafficJobPost(start, end)
      this.getTrafficJobOffer(start, end)
      this.getTrafficHoneySpending(start, end)
      this.getTrafficHoneyBuying(start, end)
      this.getJobApplicationTraffic(start, end)
      this.getNewEmployer(start, end, newSeeker)
      this.getActiveEmployer(start, end, active)
      this.getTrafficActiveSeekers(start, end, active)
    },
    /**
    * @Param data String[]
    */
    changePicker (data) {
      this.tabLoading = true
      //handle closeable date picker
      if (!data) {
        this.resetDataChart();
        this.tabLoading = false
        return
      }
      const start = this.$moment(data[0])
      const end = this.$moment(data[1])
      const dateValues = end.diff(start, 'days')
      if (dateValues > 60) {
        this.$notify({
          title: "Error",
          message: "Difference between start date and end date must be less than or equal 60 days!",
          type: "error"
        });
        this.tabLoading = false
        return
      }
      this.getAllTraffic(data[0], data[1])
      this.tabLoading = false

    },
    getNewEmployer (start, end, type) {
      this.newEmployerLoading = true
      statisticAPI.getEmployerTraffic(start, end, type).then(res => {
        if (res.data.success) {
          let labels = []
          let count = []

          this.newEmployer.data = res.data.data
          res.data.data.map(e => {
            labels.push(e.date)
            count.push(e.count)
          })
          this.labelNewEmployer = labels
          this.newEmployer.data = count
        }
        this.newEmployerLoading = false
      })
        .catch(error => {
          this.$notify({
            title: "Error",
            message: "Loading New Employer failed!",
            type: "error"
          });

          this.newEmployerLoading = false
        })
    },
    getActiveEmployer (start, end, type) {
      this.activeEmployerLoading = true
      statisticAPI.getEmployerTraffic(start, end, type).then(res => {
        if (res.data.success) {
          let labels = []
          let count = []
          this.activeEmployer.data = res.data.data
          res.data.data.map(e => {
            labels.push(e.date)
            count.push(e.count)
          })
          this.labelActiveEmployer = labels
          this.activeEmployer.data = count
        }
        this.activeEmployerLoading = false
      })
        .catch(error => {
          this.$notify({
            title: "Error",
            message: "Loading Active Employer failed!",
            type: "error"
          });

          this.activeEmployerLoading = false
        })
    },
    getTrafficSeekerNew (start, end, type) {
      this.newSeekersLoading = true
      statisticAPI.getTrafficSeeker(start, end, type).then(res => {
        if (res.data.success) {
          let labels = []
          let count = []
          this.seekers.data = res.data.data
          res.data.data.map(e => {
            labels.push(e.date)
            count.push(e.count)
          })
          this.labelsSeeker = labels
          this.seekers.data = count
        }
        this.newSeekersLoading = false
      })
        .catch(error => {
          this.$notify({
            title: "Error",
            message: "Loading New Job Seeker failed!",
            type: "error"
          });

          this.newSeekersLoading = false
        })
    },
    getTrafficActiveSeekers (start, end, type) {
      this.ActiveSeekersLoading = true
      statisticAPI.getTrafficSeeker(start, end, type).then(res => {
        if (res.data.success) {
          let labels = []
          let count = []
          this.ActiveSeekers.data = res.data.data
          res.data.data.map(e => {
            labels.push(e.date)
            count.push(e.count)
          })
          this.labelActiveJobSeeks = labels
          this.ActiveSeekers.data = count
        }
        this.ActiveSeekersLoading = false
      })
        .catch(error => {
          this.$notify({
            title: "Error",
            message: "Loading Active Seeker failed!",
            type: "error"
          });

          this.ActiveSeekersLoading = false
        })
    },
    getTrafficSeekerProfileCompleted (start, end, type) {
      this.profileCompletedSeekerLoading = true
      statisticAPI.getTrafficSeeker(start, end, type).then(res => {
        if (res.data.success) {
          let labels = []
          let count = []
          this.profilecomplete_seekers.data = res.data.data
          res.data.data.map(e => {
            labels.push(e.date)
            count.push(e.count)
          })
          this.labelsProfileCompletedSeeker = labels
          this.profilecomplete_seekers.data = count
        }
        this.profileCompletedSeekerLoading = false
      })
        .catch(error => {
          this.$notify({
            title: "Error",
            message: "Loading Seeker with Profile completed failed!",
            type: "error"
          });

          this.profileCompletedSeekerLoading = false
        })
    },
    //!TODO: fix o day
    getTrafficWorkplace (start, end) {
      this.workplacesLoading = true
      statisticAPI.getTrafficWorkplace(start, end).then(res => {
        if (res.data.success) {
          let labels = []
          let count = []
          this.workplaces.data = res.data.data
          res.data.data.map(e => {
            labels.push(e.date)
            count.push(e.count)
          })
          this.labelsWorkplaces = labels
          this.workplaces.data = count
        }
        this.workplacesLoading = false
      })
        .catch(error => {
          this.$notify({
            title: "Error",
            message: "Loading Workplaces failed!",
            type: "error"
          });

          this.workplacesLoading = false
        })
    },
    getTrafficChat (start, end) {
      this.chatsLoading = true
      statisticAPI.getTrafficChat(start, end).then(res => {
        if (res.data.success) {
          let labels = []
          let count = []
          this.chats.data = res.data.data
          res.data.data.map(e => {
            labels.push(e.date)
            count.push(e.count)
          })
          this.labelChats = labels
          this.chats.data = count
        }
        this.chatsLoading = false
      })
        .catch(error => {
          this.$notify({
            title: "Error",
            message: "Loading Chats failed!",
            type: "error"
          });

          this.chatsLoading = false
        })
    },
    getTrafficJobPost (start, end) {
      this.jobspostsLoading = true
      statisticAPI.getTrafficJobPost(start, end).then(res => {
        if (res.data.success) {
          let labels = []
          let count = []
          this.jobs_post.data = res.data.data
          res.data.data.map(e => {
            labels.push(e.date)
            count.push(e.count)
          })
          this.labelJobsPosts = labels
          this.jobs_post.data = count
        }
        this.jobspostsLoading = false
      })
        .catch(error => {
          this.$notify({
            title: "Error",
            message: "Loading Job Post failed!",
            type: "error"
          });

          this.jobspostsLoading = false
        })
    },
    getTrafficJobOffer (start, end) {
      this.jobsoffersLoading = true
      statisticAPI.getTrafficJobOffer(start, end).then(res => {
        if (res.data.success) {
          let labels = []
          let count = []
          this.jobs_offer.data = res.data.data
          res.data.data.map(e => {
            labels.push(e.date)
            count.push(e.count)
          })
          this.labelJobsOffers = labels
          this.jobs_offer.data = count
        }
        this.jobsoffersLoading = false
      })
        .catch(error => {
          this.$notify({
            title: "Error",
            message: "Loading Job Offer failed!",
            type: "error"
          });

          this.jobsoffersLoading = false
        })
    },
    // get application job
    getJobApplicationTraffic (start, end) {
      this.JobApplicationLoading = true
      statisticAPI.getJobApplicationTraffic(start, end).then(res => {
        if (res.data.success) {
          let labels = []
          let count = []
          this.Application_chart.data = res.data.data
          res.data.data.map(e => {
            labels.push(e.date)
            count.push(e.count)
          })
          this.labelJobApplication = labels
          this.Application_chart.data = count
        }
        this.JobApplicationLoading = false
      })
        .catch(error => {
          this.$notify({
            title: "Error",
            message: "Loading Job Application failed!",
            type: "error"
          });

          this.JobApplicationLoading = false
        })
    },
    // end
    getTrafficHoneySpending (start, end) {
      this.honeyspendingLoading = true
      statisticAPI.getTrafficHoneySpending(start, end).then(res => {
        if (res.data.success) {
          const labels = []
          const total = []

          this.honeysSpending.data = res.data.data
          res.data.data.map(e => {
            labels.push(e.date)
            total.push(e.total.toString().replace(/-/g, " "))
          })
          this.labelHoneySpending = labels
          this.honeysSpending.data = total
        }
        this.honeyspendingLoading = false
      })
        .catch(error => {
          this.$notify({
            title: "Error",
            message: "Loading Honey Spending failed!",
            type: "error"
          });

          this.honeyspendingLoading = false
        })
    },
    getTrafficHoneyBuying (start, end) {
      this.honeybuyingLoading = true
      statisticAPI.getTrafficHoneyBuying(start, end).then(res => {
        if (res.data.success) {
          let labels = []
          let total = []
          this.honeysBuying.data = res.data.data
          this.honeysBuying.data = res.data.data
          res.data.data.map(e => {
            labels.push(e.date)
            total.push(e.total)
          })
          this.labelHoneyBuying = labels
          this.honeysBuying.data = total

        }
        this.honeybuyingLoading = false
      })
        .catch(error => {
          this.$notify({
            title: "Error",
            message: "Loading Honey Buying failed!",
            type: "error"
          });

          this.honeybuyingLoading = false
        })
    },
    resetDataChart () {
      this.labelsSeeker = []
      this.labelsWorkplaces = []
      this.labelChats = []
      this.labelJobsPosts = []
      this.labelJobsOffers = []
      this.labelHoneyBuying = []
      this.labelHoneySpending = []
      this.labelJobApplication = []
      this.labelActiveJobSeeks = []
      this.labelsProfileCompletedSeeker = []
      this.labelNewEmployer = []
      this.labelActiveEmployer = []


      this.seekers.data = [];
      this.workplaces.data = [];
      this.chats.data = [];
      this.jobs_offer.data = [];
      this.jobs_post.data = [];
      this.honeysBuying.data = [];
      this.honeysSpending.data = [];
      this.Application_chart.data = [];
      this.ActiveSeekers.data = [];
      this.newEmployer.data = [];
      this.activeEmployer.data = [];
      this.profilecomplete_seekers.data = [];
    },
  },
  created () {
    this.getAllTraffic()
  },
  beforeUpdate () {

  },
  mounted () {


  },
}
</script>
<style scope>
.el-row-custom-bt-20 {
  margin-bottom: 20px;
}
.chart-box.chart-box-h100 .el-tabs__nav-wrap.is-top {
  display: none;
}
.chart-box.chart-box-h100 .el-tabs__content {
  overflow: inherit;
}
canvas.chartjs {
  /* position: relative; */
}
.card-base-chart {
}
.el-radio-group-custom label.el-radio {
  margin-left: 10px;
  margin-bottom: 15px;
}
.select-chart-custom {
  margin-right: 10px;
  width: auto;
}
.datepicker-chart-custom {
  width: 50%;
}
canvas.chartjs {
  position: inherit;
  margin: auto;
}
.el-card.box-card.box-card-custom-height .el-card__body {
  min-height: 35px !important;
}
div.row-filter-chart {
  margin-left: 0 !important;
  margin-right: 0 !important;
}
</style>
